#!/usr/bin/perl

use strict;

use Time::Local;

$main::Env{TZ} = ':/usr/share/zoneinfo/Europe/Moscow';

if (scalar(@ARGV) < 1) {
  die "No args given\nUsage: sani2db.pl <chatlog.sani>\n";
}
my $file = $ARGV[0];

$file =~ m/\/(.*)\/(.*)@.*\/(\d*)\/(\d*)\/\D*(\d+)/;
my $server = $1;
my $room = $2;
my $year = $3;
my $month = $4 - 1;
my $rmonth = $4;
my $day = $5;

my $table = "$2\@$1";

open (INFILE, "<$file") or die ("Cannot open file: $file\n");
my @log = <INFILE>;
close INFILE;

print "BEGIN;";
print "CREATE TABLE IF NOT EXISTS \"$table\" (server char(50), room char(50), utc int, year int, mon int, day int, hour int, min int, sec int, type char(20), member char(20), params char(50));";
foreach(@log) {
  if (m/(\d\d):(\d\d):(\d\d) (.*?) (.*)/) {
    my $time = timelocal($3, $2, $1, $day, $month, $year);
    (my $gsec, my $gmin, my $ghour, my $gmday, my $gmon, my $gyear) = gmtime($time);
    $gyear = $gyear + 1900;
    $gmon = $gmon + 1;
    my $mp = $5;
    my $type = $4;
    my $member; my $params;
    if ($mp =~ m/^(.*?) (.*)/) {
      $member = $1;
      $params = $2;
    } else {
      $member = $mp;
      $params = '';
    }
    print "INSERT INTO \"$table\" values ('$server', '$room', $time, $gyear, $gmon, $gmday, $ghour, $gmin, $gsec, '$type', '$member', '$params');\n";
  }
}

print "END;";
